
local folder, core = ...
local elapsedTime = 0 

IT = {}
IT.List = {}
IT.Data = {}
IT.Update = CreateFrame("Frame") 
IT.Update:RegisterEvent("CHAT_MSG_CHANNEL")

--[[---------------------------------------- 
---------------- Locale --------------------
----------------------------------------]]--

IT.Locale = {}

function IT.UpdateLocale(loc) 
	for k, v in pairs(loc) do 
		IT.Locale[k] = v 
	end 
end 

--[[---------------------------------------- 
------------- Slash Commands ---------------
----------------------------------------]]--

SLASH_IMPROVEDTRADECHAT1 = '/itc';
SLASH_IMPROVEDTRADECHAT2 = '/itc';
local function handler(msg, eb)
	IT.MainFrame:Show()
end
SlashCmdList["IMPROVEDTRADECHAT"] = handler; -- Also a valid assignment strategy

function IT.GetTimeString(t)
	local _time, c, h, m, s
		c = string.find(date()," ") 
	_time = string.sub(date(),c) 
	
	h, m, s = strsplit(":",_time or " ") 
	
	local str = tostring(h..":"..m..":"..s)
	
	return str
end

--[[---------------------------------------- 
------------- Sort Tradechat ---------------
----------------------------------------]]--
function IT.UpdateTimer()
	local h,m,s = strsplit(":",IT.GetTimeString() or " ") 	
	for k, v in pairs(IT.List) do
		local _hr, _min, _sec = strsplit(":",v[3] or " ") 
		
		local seconds_old = h * 60 * 60 + m * 60 + s
		local seconds_new = _hr * 60 * 60 + _min* 60 + _sec

	
		_sec = seconds_old - seconds_new
		_min = _sec / 60 
		_hr = _min / 60 
		
		if seconds_old - seconds_new >= 3600 then 
			v[5] = string.format(IT.Locale["form_hr"],_hr)
		elseif seconds_old - seconds_new >= 60 then 
			v[5] = string.format(IT.Locale["form_min"],_min)
		elseif seconds_old - seconds_new > 0 then 
			v[5] = string.format(IT.Locale["form_sec"],_sec)
		else 
			v[5] = string.format(IT.Locale["form_sec"],0)
		end
	end
	
	IT.SortList()
end

function IT.SortList()
	local function compare(w1,w2)	
		local _hr, _min, _sec = strsplit(":",w2[3] or " ") 
		local s1 = ( _hr*60*60 ) + _min* 60 + _sec
		
		_hr, _min, _sec = strsplit(":",w1[3] or " ") 
		local s2 = ( _hr*60*60 ) + _min* 60 + _sec
		
		if s1 == s2 then return true end
        if s1 < s2 then
            return true
		else 
			return false
        end
    end
	table.sort(IT.List,compare)
	table.sort(IT.Data,compare)
end 
--[[---------------------------------------- 
-------------  Update List	 ---------------
----------------------------------------]]--
function IT.UpdateResults()
	local s, author, msg
	
	for k,v in pairs(IT.List) do
		IT.List[k] = nil
	end
	
	for k,v in pairs(IT.Data) do
		s = IT.Search:GetText() or "" 
		author, msg = v[1], v[2]
		
		s 	 	= string.lower(s) 
		author 	= string.lower(author)
		msg 	= string.lower(msg)
		
		v[4] = true 
		
		if s ~= nil and s ~= "" then
			if not string.find(author,s) and not string.find(msg,s) then 
				v[4] = false 
			end 
		end
	end
	for k,v in pairs(IT.Data) do
		if v[4] then 
			IT.List[#IT.List+1] = IT.Data[k]
		end
	end
	
	IT.ScrollFrameUpdate()
end
IT.Update:SetScript("OnUpdate",function(self,et)
	elapsedTime = elapsedTime + et
	if elapsedTime < 1 then return end 
	elapsedTime = 0 
	IT.UpdateTimer()
	IT.UpdateResults()
end)
IT.Update:SetScript("OnEvent",function(self,event,...)
	local c, msg, author, channel, register, index, _ 
	
	msg, author, _, _, _, _, channel = ...
	
	if msg == nil or msg == "" then return end 
	
	c = string.find(author,"-") or 20
	author = string.sub(author,0,c-1)
	
	register = true
	for k, v in pairs(IT.Data) do
		if v[1] == author and v[2] == msg then 
			v[3] = IT.GetTimeString()
			register = false 
		end
	end	
	
	index = GetChannelName(IT.Locale["TradechatChannelName"])
	if channel == index and register then  	
		IT.Data[#IT.Data+1] = { author, msg, IT.GetTimeString(), true, string.format(IT.Locale["form_sec"],0) }
	end
end)



